#include <math.h>
#include "complex.h"
#include "fft.h"


#define SDFT_2PI 3.141593*2.0

static complex cpxAdd(complex a,complex b){
    complex c;
    c.real =a.real  + b.real;
    c.image=a.image + b.image;
    return c;
}

static complex cpxSub(complex a,complex b){
    complex c;
    c.real =a.real  - b.real;
    c.image=a.image - b.image;
    return c;
}

static complex cpxMul(complex a,complex b){
    complex c;
    c.real =(a.real*b.real )-(a.image*b.image);
    c.image=(a.real*b.image)+(b.real *a.image);
    return c;
}

/*simple usual fft (N=4) , */

// (2) input, output, inout̃fBNeBut
void fftfp(
    const complex indata[SDFT_N],   // fpfix input varname=indata.real
                                    // fpfix input varname=indata.image
    complex outdata[SDFT_N]     // fpfix output varname=outdata.real rate=5 m
                                // fpfix output varname=outdata.image rate=5 m
){
    
    int i, j;
    complex w0, w1;
    double x;
    
    for(i=0; i<SDFT_N/2; i++){
        outdata[i*2  ].real  = 0.0;
        outdata[i*2  ].image = 0.0;
        outdata[i*2+1].real  = 0.0;
        outdata[i*2+1].image = 0.0;
        for(j=0; j<SDFT_N/2; j++){
            x=SDFT_2PI*(double)(i*j)/((double)SDFT_N/2.0);
            w0.real  =  cos(x);
            w0.image = -sin(x);
            outdata[i*2] = cpxAdd(outdata[i*2],
                                  cpxMul(cpxAdd(indata[j],indata[j+SDFT_N/2]),w0));
            x=SDFT_2PI*(double)j/(double)SDFT_N;
            w1.real = cos(x);
            w1.image=-sin(x);
            outdata[i*2+1]=cpxAdd(outdata[i*2+1],
                                  cpxMul(cpxMul(cpxSub(indata[j],indata[j+SDFT_N/2]),w1),w0));
        }
    }
}
